package org.one.stone.soup.reloader;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.one.stone.soup.file.FileChangeListener;
import org.one.stone.soup.file.FileWatch;

public class Reloader implements FileChangeListener{

	private ClassLoader classLoader;
	private String jarPath;
	private FileWatch jarWatcher;
	
	private String[] args;
	private String rootClass;
	private Object root;

	private ReloadListener reloadListener;
	
	public static void main(String[] args)
	{
		String path = args[0];
		String clazz = args[1];
		String[] newArgs = new String[args.length-2];
		System.arraycopy(args,2,newArgs,0,newArgs.length);
		
		try{
			new Reloader(path,clazz,newArgs);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public Reloader(String jarPath,String rootClass,String[] args) throws Exception
	{
		this.rootClass = rootClass;
		this.jarPath = jarPath;
		this.args = args;
		
		jarWatcher = new FileWatch(jarPath,5000);
		jarWatcher.addListener(this);
		
		reload();
			
	}
	
	public void reload() throws Exception
	{
		classLoader = new URLClassLoader( new URL[]{ new File(jarPath).toURL() },getClass().getClassLoader());		
		
		Class clazz = classLoader.loadClass(rootClass);
		Method method = clazz.getMethod("main",new Class[]{String[].class});
		root = method.invoke(null,new Object[]{args});
		
		if(root instanceof ReloadListener)
		{
			reloadListener = (ReloadListener)root;
		}
	}

	public void fileChanged(File file) {
		
		boolean reload = true;
		if(reloadListener!=null)
		{
			reload = reloadListener.codeHasChangedReload();
		}
		
		if(reload)
		{
			try{
				root=null;
				System.gc();
				
				reload();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
	}
}
