/*
 * Created on 29-Sep-05
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.one.stone.soup.swing;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class JColorEditor extends JDialog implements ChangeListener{

	private Color color;

	private JSlider red;
	private JSlider green;
	private JSlider blue;
	private JSlider alpha;

	private ColorPanel colorPanel;
	private JLabel text;

	private class ColorPanel extends JLabel
	{
		public ColorPanel(String text)
		{
			super(text);

			setFont( new Font("Arial",Font.BOLD,20) );
		}

		public void paint(Graphics grfx)
		{
			grfx.setColor( Color.white );
			grfx.fillRect( 0,0,getWidth()/2,getHeight()/2 );

			grfx.setColor( Color.white );
			grfx.fillRect( getWidth()/2,getHeight()/2,getWidth()/2,getHeight()/2 );

			grfx.setColor( Color.lightGray );
			grfx.fillRect( 0,getHeight()/2,getWidth()/2,getHeight()/2 );

			grfx.setColor( Color.lightGray );
			grfx.fillRect( getWidth()/2,0,getWidth()/2,getHeight()/2 );

			super.paint(grfx);
		}
	}

	public static Color showColorEditor(Frame parent,Color color) {
		JColorEditor editor = new JColorEditor( parent,color );
		editor.setVisible(true);
		editor.dispose();

		return editor.getColor();
	}

	public JColorEditor(Frame parent,Color color)
	{
		super(parent);

		this.color = color;

		Container pane = getContentPane();
		pane.setLayout(new GridBagLayout());

		red = createSlider(pane,"Red",0);
		green = createSlider(pane,"Green",1);
		blue = createSlider(pane,"Blue",2);
		alpha = createSlider(pane,"Alpha",3);

		red.setValue(color.getRed());
		green.setValue(color.getGreen());
		blue.setValue(color.getBlue());
		alpha.setValue(color.getAlpha());

		GridBagConstraints cell = new GridBagConstraints();
		cell.gridx = 2;
		cell.gridy = 0;
		cell.gridheight = 4;
		cell.anchor = GridBagConstraints.WEST;
		colorPanel = new ColorPanel("  Color  ");
		colorPanel.setForeground(color);
		pane.add( colorPanel,cell );


		cell = new GridBagConstraints();
		cell.gridx = 0;
		cell.gridy = 4;
		cell.gridwidth = 3;
		cell.anchor = GridBagConstraints.CENTER;
		text = new JLabel("Red:"+color.getRed()+" Blue:"+color.getBlue()+" Green:"+color.getGreen()+" Alpha:"+color.getAlpha());
		pane.add( text,cell );

		setModal(true);
		pane.doLayout();
		pack();
		setResizable(false);
		
		setLocation(parent.getLocation());
	}

	private JSlider createSlider(Container pane,String name,int row)
	{
		GridBagConstraints cell = new GridBagConstraints();
		cell.gridx = 0;
		cell.gridy = row;
		cell.anchor = GridBagConstraints.WEST;
		pane.add( new JLabel(name),cell );
		cell = new GridBagConstraints();
		cell.gridx = 1;
		cell.gridy = row;
		cell.anchor = GridBagConstraints.WEST;
		JSlider slider = new JSlider(0,255);
		pane.add( slider,cell );
		slider.addChangeListener(this);

		return slider;
	}

	public void addChangeListener(ChangeListener listener)
	{
		red.addChangeListener(listener);
		green.addChangeListener(listener);
		blue.addChangeListener(listener);
		alpha.addChangeListener(listener);
	}

	public void stateChanged(ChangeEvent e)
	{
		color = new Color(red.getValue(),green.getValue(),blue.getValue(),alpha.getValue());

		if(colorPanel!=null)
		{
			colorPanel.setForeground(color);
			text.setText("Red:"+color.getRed()+" Blue:"+color.getBlue()+" Green:"+color.getGreen()+" Alpha:"+color.getAlpha());

		}
	}

	public Color getColor()
	{
		return color;
	}
}
