package org.one.stone.soup.xapp;

import java.awt.Color;
import java.awt.Dimension;

import org.one.stone.soup.grfx.ScreenCapture;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xapp.containers.XappMenuBar;
import org.one.stone.soup.xml.XmlElement;

public interface XappApplicationFrame extends XappContainer{

	public abstract int getHeight();
	public abstract int getWidth();
	public abstract void setSize(int width,int height);
	public abstract void setSize(Dimension size);
	
	public abstract void setContainer(XappContainer container);
	
	public abstract void show();
	public abstract void refresh();
	public abstract void dispose();
	public abstract boolean destroy();
	
	public abstract String getTitle();
	public abstract void setTitle(String title);
	
	public abstract XappMenuBar getXappMenuBar();
	public abstract void setXappMenuBar(XappMenuBar menuBar);
	public void setTheme(XmlElement xTheme);	

	public abstract void setForegroundColor(Color color);
	public abstract void setBackgroundColor(Color color);
	
	public abstract void setRecorder(ScreenCapture recorder);
	
	public abstract void showMessage(String message);
	public abstract void showError(String message);
	public abstract boolean askForConfirmation(String messageLines);
	public abstract String askForValue(String query,String value);
	public abstract String askForSelection(String query,String title,String[] options,String value);
}