package org.one.stone.soup.xapp.javascript;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.EcmaError;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.XappSimpleAPI;
import org.one.stone.soup.xml.XmlElement;

public class JavascriptEngine{
	
	private Context jsContext;
	private Scriptable jsScope;

	public JavascriptEngine()
	{
		jsContext = Context.enter();
		jsScope = jsContext.initStandardObjects();
		
		XappSimpleAPI api = XappRootApplication.getAPI();
		
		Object wrappedOut = Context.toObject( api, jsScope); 
		ScriptableObject.putProperty(jsScope, "Xapp", wrappedOut);
		
		XmlElement scripts = XappRootApplication.getConfig().findElements("xapp/application/javascript");
		for(int loop=0;loop<scripts.getElementCount();loop++)
		{
			String javascript = scripts.getElementByIndex(loop).getValue();
			runJavascript(javascript);
		}
	}
	
	public void register(Object object,String alias)
	{
		Object wrappedOut = Context.toObject( object, jsScope); 
		ScriptableObject.putProperty(jsScope, alias, wrappedOut);		
	}
	
	public String runJavascript(String script)
	{
		try{
			jsContext = Context.enter();
			return Context.toString( jsContext.evaluateString(jsScope, script, "Javascript Engine", 1, null) );
		}

		catch(EcmaError ee)
		{
			return"#ERROR:"+ee;
		}
		catch(Exception e)
		{
			return "#ERROR:"+e;
		}
	}
}
