package org.one.stone.soup.xapp.plugins;

import org.one.stone.soup.xapp.XappPlugin;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.form.XForm;
import org.one.stone.soup.xapp.containers.tabs.XappTab;
import org.one.stone.soup.xapp.containers.tabs.XappTabs;
import org.one.stone.soup.xapp.factories.XappMenuFactory;
import org.one.stone.soup.xapp.factories.XappPluginFactory;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlCloner;

public class NativeProcessPlugin extends XappPlugin {

	public NativeProcessPlugin(String fileName,XmlElement definition)
	{
		super(fileName,definition);
	}
	
	public void initialise() {
	}

	public XmlElement getMenu() {
		XmlElement xMenu = XappMenuFactory.getMenuDefinition("Process");
		XappMenuFactory.addMenuItem(xMenu,"Add Process","addProcess");
		
		return xMenu;
	}

	public XmlElement getActions() {
		XmlElement xActions = XappPluginFactory.getActionsDefinition();
		XappPluginFactory.addAction(this,xActions,"addProcess");
		
		return xActions;
	}

	public void addProcessTable()
	{
		String name = XappRootApplication.askForValue("Process Name","");
		if(name==null || name.length()==0)
		{
			return;
		}
		
		String tabsName = getDefinition().getElementByName("tabs").getValue();
		XappTabs tabs = ((XappTabs)XappRootApplication.getComponent(tabsName));
		XmlElement xForm = XmlCloner.getClone(getDefinition().getElementByName("form"));
		XappTab tab = tabs.getTab(name);
		
		XForm table = XappRootApplication.getComponentFactory().buildForm(xForm,XappRootApplication.getComponentStore());
		tab.add(name,table);
	}
}
