package org.one.stone.soup.xapp.plugins;

import org.one.stone.soup.xapp.XappPlugin;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.tree.XTree;
import org.one.stone.soup.xapp.controller.xml.XmlApplication;
import org.one.stone.soup.xapp.factories.XappMenuFactory;
import org.one.stone.soup.xapp.factories.XappPluginFactory;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlPathSearch;

public class XPathSearchPlugin extends XappPlugin{
	
	public XPathSearchPlugin(String pluginFileName,XmlElement definition)
	{
		super(pluginFileName,definition);

		buildForm();		
	}
	
	public void initialise()
	{
	}

	public XmlElement getMenu() {
		XmlElement xMenu = XappMenuFactory.getMenuDefinition("Search");
		XappMenuFactory.addMenuItem(xMenu,"XPath Search","showSearch");
		
		return xMenu;
	}

	public XmlElement getActions() {
		XmlElement xActions = XappPluginFactory.getActionsDefinition();
		XappPluginFactory.addAction(this,xActions,"showSearch");
		XappPluginFactory.addAction(this,xActions,"search");
		
		return xActions;
	}

	public XmlElement getData()
	{
		return form.getData();
	}
	
	public void setData(XmlElement data) {
		form.setData(data);
	}
	
	public void showSearch()
	{
		frame.show();
	}
	
	public void search()
	{	
		XmlElement data = form.getData();
		String query = data.getElementByName("query").getValue();
		
		XmlElement root = XmlApplication.getXmlData();
		XmlPathSearch search = new XmlPathSearch( root );
		XmlElement result = search.findElements( query );
		XTree tree = (XTree)XappRootApplication.getComponent("treeView");

		tree.selectNodes(result);
	}
}
