/*
 * Created on 01-Nov-05
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.one.stone.soup.xapp.swing;

import java.awt.Component;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.io.File;
import java.io.IOException;
import java.io.StringReader;
import java.util.Vector;

import org.one.stone.soup.file.FileHelper;
import org.one.stone.soup.xapp.XappPersister;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.dnd.XappDragSource;

public class XappSwingDragSource implements XappDragSource{

	private DragSource dragSource;
	private String name;
	private XappPersister source;

	public class DGListener implements DragGestureListener
	{
		public void dragGestureRecognized(DragGestureEvent dge)
		{
			File temp = null;
			try{
				temp = new File(name); //File.createTempFile(name+"-",".xml");
				FileHelper.buildFile(temp.getAbsolutePath(),source.getData().toXml());
			}
			catch(Exception e)
			{
				XappRootApplication.displayException( e );
				return;
			}
			
			FileSelection data = new FileSelection( temp );
			dge.startDrag(DragSource.DefaultMoveDrop,data);
		}
	}

	public class DSListener implements DragSourceListener
	{
		public void dragDropEnd(DragSourceDropEvent dsde) {

		}

		public void dragEnter(DragSourceDragEvent dsde) {
			dsde.getDragSourceContext().setCursor(DragSource.DefaultCopyDrop);
		}

		public void dragExit(DragSourceEvent dse) {
			dse.getDragSourceContext().setCursor(DragSource.DefaultCopyNoDrop);
		}

		public void dragOver(DragSourceDragEvent dsde) {
		}

		public void dropActionChanged(DragSourceDragEvent dsde) {
		}

}

    public class FileSelection extends Vector implements Transferable
    {
        final static int FILE = 0;
        final static int STRING = 1;
        final static int PLAIN = 2;
        DataFlavor flavors[] = {DataFlavor.javaFileListFlavor,
                                DataFlavor.stringFlavor,
                                DataFlavor.plainTextFlavor};
        public FileSelection(File file)
        {
            addElement(file);
        }
        /* Returns the array of flavors in which it can provide the data. */
        public synchronized DataFlavor[] getTransferDataFlavors() {
    	return flavors;
        }
        /* Returns whether the requested flavor is supported by this object. */
        public boolean isDataFlavorSupported(DataFlavor flavor) {
            boolean b  = false;
            b |=flavor.equals(flavors[FILE]);
            b |= flavor.equals(flavors[STRING]);
            b |= flavor.equals(flavors[PLAIN]);
        	return (b);
        }
        /**
         * If the data was requested in the "java.lang.String" flavor,
         * return the String representing the selection.
         */
        public synchronized Object getTransferData(DataFlavor flavor)
    			throws UnsupportedFlavorException, IOException {
    	if (flavor.equals(flavors[FILE])) {
    	    return this;
    	} else if (flavor.equals(flavors[PLAIN])) {
    	    return new StringReader(((File)elementAt(0)).getAbsolutePath());
    	} else if (flavor.equals(flavors[STRING])) {
    	    return((File)elementAt(0)).getAbsolutePath();
    	} else {
    	    throw new UnsupportedFlavorException(flavor);
    	}
        }
    }


	private DGListener dgListener;

	public XappSwingDragSource(Component source,XappPersister sender,String name)
	{
		dgListener = new DGListener();

		dragSource = DragSource.getDefaultDragSource();
		dragSource.createDefaultDragGestureRecognizer(
		  	source,
			DnDConstants.ACTION_COPY_OR_MOVE,
			dgListener
		);
		
		this.source = sender;
		this.name = name;
	}
}
