package org.one.stone.soup.xapp.swing.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;

import org.one.stone.soup.entity.KeyValuePair;
import org.one.stone.soup.grfx.ColorHelper;
import org.one.stone.soup.swing.JAnchor;
import org.one.stone.soup.xapp.XappComponentStore;
import org.one.stone.soup.xapp.XappPersister;
import org.one.stone.soup.xapp.XappReceiver;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.XappSender;
import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.components.XappField;
import org.one.stone.soup.xapp.components.form.XForm;
import org.one.stone.soup.xapp.components.form.XFormAdapter;
import org.one.stone.soup.xapp.components.form.XFormTableHelper;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xml.XmlElement;


public class XSwingForm extends /*JPanel*/JLayeredPane implements XappContainer,XappSender,XappReceiver,XappPersister, XForm{

	private XSwingFormLayout layout;
	private XappReceiver receiver;
	private XFormAdapter adapter;
	private String formSource;
	
	private Hashtable groups = new Hashtable();
	private Vector elements = new Vector();
	private Vector childTables = new Vector();

	private Image background = null;

	private boolean border = false;
	private boolean cellBorder = false;
	private boolean realtimeUpdate = false;

	private Object target = null;

public XSwingForm() {}
/**
 * XTable constructor comment.
 */
public XSwingForm(XmlElement table)
{
	this(table,XappRootApplication.getComponentStore());
}

public XSwingForm(XmlElement table,XappComponentStore componentStore)
{
	super();

	initialize(table,componentStore);
	formSource = table.getAttributeValueByName("name");
}

public XSwingForm(XmlElement table,XmlElement data,XappComponentStore componentStore)
{
	super();

	initialize(table,componentStore);

	setData(data);
	formSource = table.getAttributeValueByName("name");
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#initialize(org.one.stone.soup.xml.XmlElement, org.one.stone.soup.xapp.XappComponentStore)
 */
public void initialize(XmlElement table,XappComponentStore componentStore)
{
	if(table.getAttributeValueByName("border")!=null && table.getAttributeValueByName("border").equals("true"))
	{
		String title = table.getAttributeValueByName("title");
		if(title==null)
		{
			border=true;
		}
		else
		{
			setBorder(BorderFactory.createTitledBorder(title));
			border = false;
		}
	}
	if(table.getAttributeValueByName("cellBorder")!=null && table.getAttributeValueByName("cellBorder").equals("true"))
	{
		cellBorder=true;
	}
	if(table.getAttributeValueByName("realtime")!=null && table.getAttributeValueByName("realtime").equals("true"))
	{
		realtimeUpdate=true;
	}

	int cellPadding = 0;
	int rowPadding = 0;
	
	if(
			table.getAttributeValueByName("cellPadding")!=null ||
			table.getAttributeValueByName("rowPadding")!=null
	)
	{
		if(table.getAttributeValueByName("cellPadding")!=null)
		{
			cellPadding = Integer.parseInt( table.getAttributeValueByName("cellPadding") );
		}
		if(table.getAttributeValueByName("rowPadding")!=null)
		{
			rowPadding = Integer.parseInt( table.getAttributeValueByName("rowPadding") );
		}

	}
	if(cellPadding!=0 || rowPadding!=0)
	{
		XFormTableHelper.padTable(table,cellPadding,rowPadding);
	}

	XappRootApplication.getComponentFactory().setColor(this,table);
	setBackground(this,table);
	layout = XSwingFormLayout.buildTableLayout(this,table,componentStore);
	//setBackground(this,table);
	XappRootApplication.getComponentFactory().setBackground(this,table);
	setOpaque(true);
	//setBorder(BorderFactory.createTitledBorder(getName()));
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getFormSource()
 */
public String getFormSource()
{
	return formSource;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#setFormSource(java.lang.String)
 */
public void setFormSource(String source)
{
	formSource = source;
}

/**
 * XTable constructor comment.
 */

public void fire()
{
	// Reset buttons
	for(int loop=0;loop<elements.size();loop++)
	{
		if(
				elements.elementAt(loop) instanceof JButton &&
				!(elements.elementAt(loop) instanceof JAnchor && ((JAnchor)elements.elementAt(loop)).isHref() ) // Not for Href anchors
			)
		{
			JButton button = (JButton)elements.elementAt(loop);
			if(button.getName()!=null && !button.getName().equals("submit"))
			{
				button.setActionCommand("false");
			}
		}
	}

	XmlElement packet = new XmlElement("packet");
	XmlElement data = getData(false);
	packet.addChild(data);
	packet.addAttribute("name",data.getAttributeValueByName("name"));
	XmlElement item = packet.addChild("item");
	item.addAttribute("name","refresh");

	for(int loop=0;loop<elements.size();loop++)
	{
		if( elements.elementAt(loop) instanceof XSwingForm )
		{
			XSwingForm childTable = ((XSwingForm)elements.elementAt(loop));
			if(childTable.getName()==null || childTable.getName().length()==0)
			{
				XmlElement childData = childTable.getData();

				for(int loopD=0;loopD<childData.getElementCount();loopD++)
				{
					XmlElement childItem = childData.getElementByIndex(loopD);
					data.addChild( childItem );
				}
			}
			else
			{
				childTable.fire();
			}
		}
	}

	if(receiver!=null)
	{
		receiver.receiveXappData( packet );
	}
}

public void actionPerformed(ActionEvent e)
{
	if( e.getSource() instanceof JAnchor)
	{
		if( receiver!=null)
		{
			XmlElement data = new XmlElement("data");
			data.addAttribute("name",getName());

			data.addChild( getElementData( e.getSource() ) );

			receiver.receiveXappData( data );
		}
	}
	else if( e.getSource() instanceof JButton)
	{
		if( ((JButton)e.getSource()).getName().equals("submit") && receiver!=null)
		{
			receiver.receiveXappData( getData() );
		}
		else
		{
			if( receiver!=null)
			{
				XmlElement data = new XmlElement("action");
				data.addAttribute("name",getName());

				data.addChild( getElementData( e.getSource() ) );

				receiver.receiveXappData( data );
			}

		}
	}
	else if(realtimeUpdate==true && receiver!=null)
	{
		XmlElement packet = new XmlElement("packet");
		XmlElement data = getData();
		packet.addChild(data);
		packet.addAttribute("name",data.getAttributeValueByName("name"));

		XmlElement item = packet.addChild("item");
		item.addAttribute("name","refresh");
		receiver.receiveXappData( packet );
	}
}
/*
	You can't add a listener to a textArea

	You can't listen to a radio button group. This method adds a listener to
	each radio button.
*/
public void addActionListener(String name, ActionListener listener)
{
	for(int loop=0;loop<elements.size();loop++)
	{
		if( !(elements.elementAt(loop) instanceof Component) )
		{
			continue;
		}
		Component comp = (Component)elements.elementAt(loop);
		if(comp.getName().equals(name))
		{
			if(comp instanceof JTextField)
			{
				((JTextField)comp).addActionListener(listener);
				return;
			}
			else if(comp instanceof JButton)
			{
				((JButton)comp).addActionListener(listener);
				return;
			}
			else if(comp instanceof JRadioButton)
			{
				((JRadioButton)comp).addActionListener(listener);
				return;
			}
			else if(comp instanceof JCheckBox)
			{
				((JCheckBox)comp).addActionListener(listener);
				return;
			}
			else if(comp instanceof JComboBox)
			{
				((JComboBox)comp).addActionListener(listener);
				return;
			}
		}
	}

	ButtonGroup group = (ButtonGroup)groups.get(name);

	if(group!=null)
	{
		Enumeration enumeration = group.getElements();

		while(enumeration.hasMoreElements())
		{
			JRadioButton radio = (JRadioButton)enumeration.nextElement();

			radio.addActionListener(listener);
		}
	}
}

public void add(XappComponent component) {
	elements.addElement(component);

}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#add(java.lang.String, java.awt.Component)
 */
public void add(String name,XappComponent element)
{
	Component component = super.add(name,(Component)element);
	
	if(component instanceof XSwingForm)
	{
		/*String tableName = ((XForm)component).getName();
		if(tableName.length()==0)
		{*/
			childTables.addElement( component );
		/*}*/
	}
}


/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#replaceElement(java.awt.Component, java.awt.Component)
 */
public void replaceElement(java.awt.Component oldElement,java.awt.Component newElement)
{
	String layoutKey = layout.getCellName( oldElement );
	remove(oldElement);
	add(newElement.getName(),newElement);

	layout.replaceLayoutComponent(oldElement,newElement,layoutKey);

	elements.remove(oldElement);
	elements.add(newElement);
}

/*public void addGroupMember(java.lang.String group, AbstractButton member)
{
	ButtonGroup bGroup = (ButtonGroup)groups.get(group);
	if(bGroup==null)
	{
		bGroup = new ButtonGroup();
		groups.put(group,bGroup);
		member.setSelected(true);

		elements.addElement(bGroup);
	}

	bGroup.add(member);
}*/
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getData()
 */
public XmlElement getData()
{
	return getData(false);
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getData(boolean)
 */
public XmlElement getData(boolean includeButtons)
{
	XmlElement data = new XmlElement("data");

	data.addAttribute("source",formSource);
	data.addAttribute("name",getName());
	if(target!=null)
	{
		data.addAttribute("_targetHash",""+target.hashCode());
	}

	for(int loop=0;loop<elements.size();loop++)
	{
		XappComponent src = (XappComponent)elements.elementAt(loop);
		if(src instanceof XappField && src.getName()!=null)
		{
			data.addChild( src.getName() ).addValue( ((XappField)src).getData() );
		}
	}

	if(hasAdapter())
	{
		data = adapter.transformFromFormData(data);
	}
	
	return data;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getElements()
 */
public Vector getElements()
{
	return elements;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getComponentAt(int, int)
 */
public Component getComponentAt(int x,int y)
{
	/*if(!contains(x,y))
	{
		return null;
	}*/
	
	for(int loop=0;loop<elements.size();loop++)
	{
		Component component = (Component)elements.elementAt(loop);
		Point pos = component.getLocation();
		if( component.contains(x-pos.x,y-pos.y) )
		//if( component.contains(2,2) )
		{
			return component;
		}
	}
	return null;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getElement(java.lang.String)
 */
public XappComponent getElement(String name)
{
	for(int loop=0;loop<elements.size();loop++)
	{

		if(elements.elementAt(loop) instanceof XSwingForm)
		{
			XSwingForm childTable = (XSwingForm)elements.elementAt(loop);
			if(childTable.getName().length()==0)
			{
				XappComponent element = childTable.getElement(name);
				if(element!=null)
				{
					return element;
				}
			}
			else if(childTable.getName().equals(name))
			{
				return childTable;
			}
		}
		else if(elements.elementAt(loop) instanceof Component)
		{
			if(((Component)elements.elementAt(loop)).getName()==null)
			{
				continue;
			}
			else if( ((XappComponent)elements.elementAt(loop)).getName().equals(name) )
			{
				return (XappComponent)elements.elementAt(loop);
			}
		}
	}
	return null;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#getElementData(java.lang.Object)
 */
public XmlElement getElementData(Object src)
{
	XmlElement container = null;

	if(src instanceof JSlider)
	{
		container = new XmlElement(((JSlider)src).getName());
		container.addValue(""+((JSlider)src).getValue());
	}
	else if(src instanceof JColorChooser)
	{
		container = new XmlElement(((JColorChooser)src).getName());
		container.addValue(
			ColorHelper.colorToHtml(
				((JColorChooser)src).getColor()
									)
							);
	}
	else if(src instanceof XappSwingColorBrowser)
	{
		container = new XmlElement(((XappSwingColorBrowser)src).getName());
		container.addValue(((XappSwingColorBrowser)src).getText());
	}
	else if(src instanceof JTextField)
	{
		container = new XmlElement(((JTextField)src).getName());
		container.addValue(((JTextField)src).getText());
	}
	else if(src instanceof XappSwingFileEntryField)
	{
		container = new XmlElement(((XappSwingFileEntryField)src).getName());
		container.addValue(((XappSwingFileEntryField)src).getText());
	}
	else if(src instanceof JPasswordField)
	{
		container = new XmlElement(((JPasswordField)src).getName());
		container.addValue( new String(((JPasswordField)src).getPassword()) );
	}
	else if(
			src instanceof JAnchor &&
			!((JAnchor)src).isHref()
			)
	{
		container = new XmlElement(((JAnchor)src).getName());
		container.addValue(((JAnchor)src).getActionCommand());
	}
	else if(src instanceof JButton && !(src instanceof JAnchor))
	{
		container = new XmlElement(((JButton)src).getName());
		container.addValue(((JButton)src).getActionCommand());
	}
	else if(src instanceof JTextArea)
	{
		container = new XmlElement(((JTextArea)src).getName());
		container.addValue(((JTextArea)src).getText());
	}
	else if(src instanceof JLabel)
	{
		container = new XmlElement(((JLabel)src).getName());
		container.addValue(((JLabel)src).getText());
	}
	else if(src instanceof JCheckBox)
	{
		container = new XmlElement(((JCheckBox)src).getName());
		if( ((JCheckBox)src).isSelected() )
		{
			container.addValue("true");
		}
		else
		{
			container.addValue("false");
		}
	}
	else if(src instanceof JComboBox)
	{
		container = new XmlElement(((JComboBox)src).getName());
		if(((JComboBox)src).getSelectedItem()!=null)
		{
			Object selected = ((JComboBox)src).getSelectedItem();
			if(selected instanceof KeyValuePair)
			{
				container.addValue( ((KeyValuePair)selected).value );
			}
			else
			{
				container.addValue( selected.toString() );
			}
		}
	}
	else if(src instanceof ButtonGroup)
	{
		ButtonGroup group = (ButtonGroup)src;

		JRadioButton button=null;
		Enumeration enumeration = group.getElements();
		while(enumeration.hasMoreElements())
		{
			button = (JRadioButton)enumeration.nextElement();
			if(button.isSelected())
			{
				break;
			}
		}

		String groupName = null;
		enumeration = groups.keys();
		while(enumeration.hasMoreElements())
		{
			String key = enumeration.nextElement().toString();
			if( groups.get(key)==group )
			{
				groupName=key;
				break;
			}
		}

		container = new XmlElement( groupName );
		container.addValue( button.getName() );
	}
	else if(src instanceof XSwingForm)
	{
		return ((XSwingForm)src).getData();
	}
	
	return container;
}
public ButtonGroup getGroup(Object item)
{
	Enumeration enumeration = groups.elements();

	while(enumeration.hasMoreElements())
	{
		ButtonGroup group = (ButtonGroup)enumeration.nextElement();

		Enumeration enumg = group.getElements();
		while(enumg.hasMoreElements())
		{
			if( enumg.nextElement()==item )
			{
				return group;
			}
		}
	}
	return null;
}
public Dimension getPreferredSize() {

	Dimension dimension = getLayout().preferredLayoutSize(null);

	//System.out.println("Name:"+this.getName()+" size:"+dimension);

	return dimension;
}
public void paint(Graphics grfx)
{
	//System.out.println( "paint table name="+this.getName()+" size="+this.getPreferredSize()+" position="+this.getX()+","+this.getY() );

	if(background!=null)
	{
		int imgWidth = background.getWidth(this);
		int imgHeight = background.getHeight(this);
		int x = getWidth()/imgWidth+1;
		int y = getHeight()/imgHeight+1;

		for(int loopX=0;loopX<x;loopX++)
		{
		for(int loopY=0;loopY<y;loopY++)
		{
			grfx.drawImage(background,loopX*imgWidth,loopY*imgHeight,getBackground(),null);
		}
		}
	}
	else
	{
		super.paint(grfx);
	}

	if(border==true || cellBorder==true)
	{
		//super.paint(grfx);

		if(border==true)
		{
			//super.paint(grfx);
			int rowPos = 0;
			Color tempCol = grfx.getColor();

			for(int loopR=0;loopR<layout.getRowCount();loopR++)
			{
				int colPos = 0;
				for(int loopC=0;loopC<layout.getColumnCount();loopC++)
				{
					Color bgColor = layout.getCellBgColor(loopR,loopC);

					if(bgColor!=null)
					{
						grfx.setColor(bgColor);
						grfx.fillRect(colPos,rowPos,layout.getColumnSize(loopC),layout.getRowSize(loopR));
					}

					colPos += layout.getColumnSize(loopC);
				}
				rowPos += layout.getRowSize(loopR);
			}

			grfx.setColor(tempCol);
			grfx.drawRect(0,0,getWidth()-1,getHeight()-1);
		}

		if(cellBorder==true)
		{
			//super.paint(grfx);
			int rowPos = 0;
			for(int loopR=0;loopR<layout.getRowCount();loopR++)
			{
				grfx.drawLine(0,rowPos,getWidth(),rowPos);
				rowPos += layout.getRowSize(loopR);
			}
			grfx.drawLine(0,rowPos,getWidth(),rowPos);

			int colPos = 0;
			for(int loopC=0;loopC<layout.getColumnCount();loopC++)
			{
				grfx.drawLine(colPos,0,colPos,getHeight());
				colPos += layout.getColumnSize(loopC);
			}
			grfx.drawLine(colPos,0,colPos,getHeight());
		}
	}
	/*else
	{
		//super.paint(grfx);
		return;
	}*/

	paintChildren(grfx);
}
public void removeActionListener(String name, ActionListener listener)
{
	for(int loop=0;loop<elements.size();loop++)
	{
		if( !(elements.elementAt(loop) instanceof Component) )
		{
			continue;
		}
		Component comp = (Component)elements.elementAt(loop);
		if(comp.getName().equals(name))
		{
			if(comp instanceof JTextField)
			{
				((JTextField)comp).removeActionListener(listener);
				return;
			}
			else if(comp instanceof JRadioButton)
			{
				((JRadioButton)comp).removeActionListener(listener);
				return;
			}
			else if(comp instanceof JCheckBox)
			{
				((JCheckBox)comp).removeActionListener(listener);
				return;
			}
			else if(comp instanceof JComboBox)
			{
				((JComboBox)comp).removeActionListener(listener);
				return;
			}
		}
	}

	ButtonGroup group = (ButtonGroup)groups.get(name);

	if(group!=null)
	{
		Enumeration enumeration = group.getElements();

		while(enumeration.hasMoreElements())
		{
			JRadioButton radio = (JRadioButton)enumeration.nextElement();

			radio.removeActionListener(listener);
		}
	}
}
public void removeElement(java.awt.Component element)
{
	elements.removeElement(element);
	remove(element);
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#setBackground(java.awt.Color)
 */
public void setBackground(Color color)
{
	super.setBackground(color);

	if(getComponentCount()==0)
	{
		return;
	}

	/*for(int loop=0;loop<getComponentCount();loop++)
	{
		Component comp = getComponent(loop);

		if(comp instanceof JScrollPane)
		{
			if(((JScrollPane)comp).getViewport()==null)
			{
				continue;
			}
			else
			{
				comp = ((JScrollPane)comp).getViewport().getView();
			}
		}

		if(comp==null)
			continue;

		if(comp instanceof JAnchor)
		{
			comp.setBackground(color);
		}
		else if(comp instanceof JLabel)
		{
			comp.setBackground(color);
		}
		else
		{
			comp.setBackground(color);
		}
	}*/

	for(int loopR=0;loopR<layout.getRowCount();loopR++)
	{
		for(int loopC=0;loopC<layout.getColumnCount();loopC++)
		{
			Color cellColor = layout.getCellBgColor(loopR,loopC);
			if(cellColor==null)
			{
				cellColor = color;
			}

			Component comp = layout.getCell(loopR,loopC);

			if(comp==null)
				continue;

			if(comp instanceof JAnchor)
			{
				comp.setBackground(cellColor);
			}
			else if(comp instanceof JLabel)
			{
				comp.setBackground(cellColor);
			}
		}
	}
}
public void setBackground(Container container,XmlElement xData)
{
	String data = xData.getAttributeValueByName("background");
	if(data!=null && data.length()>0)
	{
		try{
			background = ((XappSwingImage)XappRootApplication.getComponentFactory().getImage(data)).getImage();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	XappRootApplication.getComponentFactory().setBackground(this,xData);
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#setBackgroundImage(java.awt.Image)
 */
public void setBackgroundImage(Image img)
{
	background = img;
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#setData(org.one.stone.soup.xml.XmlElement)
 */
public void setData(XmlElement data)
{
	if(hasAdapter())
	{
		data = adapter.transformToFormData(data);
	}

	String source = data.getAttributeValueByName("source");
	if(source!=null)
	{
		setFormSource(source);
	}
	
	String name = data.getAttributeValueByName("name");
	if(name!=null)
	{
		setName(name);
	}

	for(int loop=0;loop<data.getElementCount();loop++)
	{
		XmlElement element = data.getElementByIndex(loop);
		XappComponent component = getElement( element.getName() );
		if(component instanceof XappField)
		{
			((XappField)component).setData( element.getValue() );
		}
	}
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#setForeground(java.awt.Color)
 */
public void setForeground(Color color)
{
	super.setForeground(color);

	if(getComponentCount()==0)
	{
		return;
	}

/*	for(int loop=0;loop<getComponentCount();loop++)
	{
		Component comp = getComponent(loop);

		if(comp instanceof JScrollPane)
		{
			comp = ((JScrollPane)comp).getViewport().getView();
		}
		if(comp instanceof JScrollPane)
		{
			if(((JScrollPane)comp).getViewport()==null)
			{
				continue;
			}
			else
			{
				comp = ((JScrollPane)comp).getViewport().getView();
			}
		}

		if(comp==null)
			continue;

		if(comp instanceof JTextComponent)
		{
			comp.setBackground(color);
		}
		else
		{
			comp.setForeground(color);
		}
	}*/

/*	if(elements==null)
	{
		return;
	}

	for(int loop=0;loop<elements.size();loop++)
	{
		Component comp = (Component)elements.elementAt(loop);
		if(comp instanceof JTextComponent)
		{
			comp.setBackground(color);
		}
		else
		{
			comp.setForeground(color);
		}
	}*/
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#addReceiver(org.one.stone.soup.xapp.XappReceiver)
 */
public void addReceiver(XappReceiver receiver)
{
	this.receiver = receiver;
	
	for(int loop=0;loop<childTables.size();loop++)
	{
		XSwingForm form = (XSwingForm)childTables.elementAt(loop);
		form.addReceiver(receiver);
	}
}
/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#removeReceiver(org.one.stone.soup.xapp.XappReceiver)
 */
public void removeReceiver(XappReceiver receiver)
{
	this.receiver = null;
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.form.XForm#receiveXappData(org.one.stone.soup.xml.XmlElement)
 */
public void receiveXappData(XmlElement data)
{
	String sourceName = data.getAttributeValueByName("name");

	if(sourceName==null || sourceName.length()==0)
	{
		fire();
	}
	else
	{
		data.setAttributeValue( "name",getName()+"."+data.getAttributeValueByName("name") );
		
		if(hasAdapter())
		{
			data = adapter.transformFromFormData(data);
		}
		
		if(receiver!=null)
		{
			receiver.receiveXappData(data);
		}
	}

}

	public void stateChanged(ChangeEvent e) {
		ActionEvent event = new ActionEvent( e.getSource(),0,"changed" );
		actionPerformed( event );
	}

	public void setTarget(Object target)
	{
		this.target = target;

		for(int loop=0;loop<elements.size();loop++)
		{
			Object src = elements.elementAt(loop);

			if(src instanceof XSwingForm)
			{
				((XSwingForm)src).setTarget(target);
			}
		}
	}

	public Object getTarget()
	{
		return target;
	}

	public void setEnabled(boolean state)
	{
		for(int loop=0;loop<elements.size();loop++)
		{
			if(elements.elementAt(loop) instanceof Component)
			{
				((Component)elements.elementAt(loop)).setEnabled(state);
			}
			else if(elements.elementAt(loop) instanceof XSwingForm)
			{
				((XSwingForm)elements.elementAt(loop)).setEnabled(state);
			}
		}
	}
	
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.components.form.XForm#setAdapter(org.one.stone.soup.xapp.components.form.XFormAdapter)
	 */
	public void setAdapter(XFormAdapter adapter)
	{
		this.adapter = adapter;
	}
	
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.components.form.XForm#hasAdapter()
	 */
	public boolean hasAdapter()
	{
		if(adapter==null)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
	
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.components.form.XForm#getAdapter()
	 */
	public XFormAdapter getAdapter()
	{
		return adapter;
	}
	
	public String toString()
	{
		return "XForm "+getName();
	}
	
	public String getValue()
	{
		return null;
	}
	
	public void refresh()
	{
		doLayout();
	}
	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub
		
	}
	

	public void setTip(String text)
	{
		setToolTipText(text);
	}
}
