package org.one.stone.soup.xapp.swing.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import org.one.stone.soup.xapp.XappComponentStore;
import org.one.stone.soup.xapp.XappReceiver;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.XappSender;
import org.one.stone.soup.xapp.components.XappMenu;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xapp.containers.XappPopup;
import org.one.stone.soup.xapp.swing.factories.XappSwingComponentFactory;
import org.one.stone.soup.xml.XmlElement;

public class XappSwingPopup implements ActionListener,XappSender, XappPopup {
	
	private String name;
	private XappComponentStore menuMap;
	private XappReceiver receiver;
	private JPopupMenu popup;

public XappSwingPopup(XmlElement xPopup) {
	super();

	init(xPopup);
}
public void setName(String name)
{
	this.name = name;
}
public String getName()
{
	return name;
}
public void actionPerformed(java.awt.event.ActionEvent e)
{
	XmlElement xui = new XmlElement("popup");
	xui.addAttribute("name",getName());

	XmlElement item = xui.addChild(((JMenuItem)e.getSource()).getName());
	item.addValue(e.getActionCommand());

	receiver.receiveXappData( xui );
}
private void init(XmlElement xMenu)
{
	String name = xMenu.getAttributeValueByName("name");
	if(name!=null)
	{
		setName(name);
	}
	menuMap = new XappComponentStore();
	
	XappMenu jMenu = new XappSwingMenu();
	jMenu.setName("Menu");
	XappRootApplication.getComponentFactory().buildMenu(xMenu,this,(XappMenu)jMenu,menuMap);
	
	popup = ((JMenu)jMenu).getPopupMenu();
}

public void setEnabled(String path, boolean state)
{
	JMenuItem item = (JMenuItem)menuMap.getXappComponent(path);

	if(item!=null)
	{
		item.setEnabled(state);
	}
}
public void addReceiver(XappReceiver receiver)
{
	this.receiver = receiver;
}

public void removeReceiver(XappReceiver receiver)
{
	this.receiver = null;
}

public void show(Component owner,int x,int y)
{
	popup.show(owner,x,y);
	popup.repaint();
}

public void hide()
{
	popup.hide();
	this.receiver=null;
}

public void show(XappContainer owner,int x,int y)
{
	show((Component)owner,x,y);
}
public void addActionListener(ActionListener actionListener) {
	// TODO Auto-generated method stub
	
}
public void setBackground(Color color) {
	popup.setBackground(color);
	
}
public void setForeground(Color color) {
	popup.setForeground(color);
}
public void setTip(String toolTip) {
	popup.setToolTipText(toolTip);
}
}
