package org.one.stone.soup.xapp.swing.components;

import java.awt.event.ActionListener;

import javax.swing.JInternalFrame;
import javax.swing.JLayeredPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.plaf.metal.MetalLookAndFeel;

import org.one.stone.soup.xapp.components.XappTextArea;

public class XappSwingTextArea extends JScrollPane implements XappTextArea {

	private JTextArea text;
	
	public XappSwingTextArea()
	{
		text = new JTextArea();
		setViewportView(text);
	}
	
	public String getData() {
		return text.getText();
	}

	public void setData(String value) {
		text.setText(value);
	}

	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub

	}

	public void setTip(String toolTip) {
		text.setToolTipText(toolTip);
	}

	public void setStyle(String style)
	{
		if(style==null || style.equals("normal"))
		{
			setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			setViewportView(text);
		}
		else if(style.equals("frame"))
		{
			setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		}
		else if(style.equals("plain"))
		{
			setBorder(null);
			
			setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			
			text.setBackground(MetalLookAndFeel.getDesktopColor());
			text.setForeground(MetalLookAndFeel.getWhite());
			
			setSize(text.getSize());
		}
	}

	public void setColumns(int columns) {
		text.setColumns(columns);
	}

	public void setRows(int rows) {
		text.setRows(rows);
	}

	public void setEditable(boolean state) {
		text.setEditable(state);
	}
	
	public void append(String newData)
	{
		text.append(newData);
	}
}
